package ru.dbotthepony.kstarbound


import org.apache.logging.log4j.LogManager
import org.lwjgl.Version
import org.lwjgl.glfw.GLFW.glfwSetWindowShouldClose
import ru.dbotthepony.kstarbound.client.StarboundClient
import ru.dbotthepony.kstarbound.client.network.ClientConnection
import ru.dbotthepony.kstarbound.io.BTreeDB
import ru.dbotthepony.kstarbound.io.readVarInt
import ru.dbotthepony.kstarbound.json.VersionedJson
import ru.dbotthepony.kstarbound.server.IntegratedStarboundServer
import ru.dbotthepony.kstarbound.server.world.LegacyChunkSource
import ru.dbotthepony.kstarbound.server.world.ServerWorld
import ru.dbotthepony.kstarbound.util.AssetPathStack
import ru.dbotthepony.kstarbound.world.Direction
import ru.dbotthepony.kstarbound.world.WorldGeometry
import ru.dbotthepony.kstarbound.world.api.MutableCell
import ru.dbotthepony.kstarbound.world.entities.ItemEntity
import ru.dbotthepony.kstarbound.world.entities.PlayerEntity
import ru.dbotthepony.kstarbound.world.entities.WorldObject
import ru.dbotthepony.kvector.vector.Vector2d
import ru.dbotthepony.kvector.vector.Vector2i
import java.io.BufferedInputStream
import java.io.ByteArrayInputStream
import java.io.DataInputStream
import java.io.File
import java.util.*
import java.util.concurrent.TimeUnit
import java.util.zip.Inflater
import java.util.zip.InflaterInputStream

private val LOGGER = LogManager.getLogger()

fun main() {
	LOGGER.info("Running LWJGL ${Version.getVersion()}")

	//Thread.sleep(6_000L)

	val db = BTreeDB(File("F:\\SteamLibrary\\steamapps\\common\\Starbound - Unstable\\storage\\universe\\389760395_938904237_-238610574_5.world"))
	//val db = BTreeDB(File("world.world"))

	val meta = DataInputStream(BufferedInputStream(InflaterInputStream(ByteArrayInputStream(db.read(byteArrayOf(0, 0, 0, 0, 0))), Inflater())))

	println(meta.readInt())
	println(meta.readInt())

	// println(VersionedJson(meta))

	val server = IntegratedStarboundServer(File("./"))
	val client = StarboundClient()
	val world = ServerWorld(server, 0L, WorldGeometry(Vector2i(3000, 2000), true, false))
	world.addChunkSource(LegacyChunkSource(db))
	world.startThread()

	//Starbound.addFilePath(File("./unpacked_assets/"))
	Starbound.addPakPath(File("J:\\Steam\\steamapps\\common\\Starbound\\assets\\packed.pak"))

	/*for (folder in File("J:\\Steam\\steamapps\\workshop\\content\\211820").list()!!) {
		val f = File("J:\\Steam\\steamapps\\workshop\\content\\211820\\$folder\\contents.pak")

		if (f.exists()) {
			Starbound.addPakPath(f)
		}
	}*/

	//Starbound.addPakPath(File("packed.pak"))

	Starbound.initializeGame()

	Starbound.mailboxInitialized.submit {
		//ply = PlayerEntity(client.world!!)

		//ply!!.position = Vector2d(225.0, 680.0)
		//ply!!.spawn()

		//for (chunkX in 17 .. 18) {
		//for (chunkX in 14 .. 24) {
		for (chunkX in 0 .. 100) {
		//for (chunkX in 0 .. 17) {
		//	for (chunkY in 21 .. 21) {
			for (chunkY in 18 .. 24) {
				//val data = db.read(byteArrayOf(1, (chunkX shr 8).toByte(), chunkX.toByte(), (chunkY shr 8).toByte(), chunkY.toByte()))
				//val data2 = db.read(byteArrayOf(2, (chunkX shr 8).toByte(), chunkX.toByte(), (chunkY shr 8).toByte(), chunkY.toByte()))

				/*if (data != null) {
					var reader = DataInputStream(BufferedInputStream(InflaterInputStream(ByteArrayInputStream(data), Inflater())))
					reader.skipBytes(3)

					val chunk = world.chunkMap.compute(chunkX, chunkY)

					if (chunk != null) {
						for (y in 0 .. 31) {
							for (x in 0 .. 31) {
								check(chunk.setCell(x, y, MutableCell().read(reader)))
							}
						}
					}
				}*/

				/*if (data2 != null) {
					val reader = DataInputStream(BufferedInputStream(InflaterInputStream(ByteArrayInputStream(data2), Inflater())))
					val i = reader.readVarInt()

					for (i2 in 0 until i) {
						val obj = VersionedJson(reader)

						if (obj.identifier == "ObjectEntity") {
							try {
								WorldObject(world, obj.content.asJsonObject).spawn()
								//println(obj.content)
								//println(created)
							} catch (err: Throwable) {

							}
						}
					}

					//val read = BinaryJsonReader.readElement(reader)
					//println(read)
				}*/
			}
		}

		//client.world!!.parallax = Starbound.parallaxAccess["garden"]

		val rand = Random()

		for (i in 0 until 0) {
			val item = ItemEntity(world, Registries.items.keys.values.random().value)

			item.position = Vector2d(225.0 - i, 785.0)
			item.spawn()
			item.movement.velocity = Vector2d(rand.nextDouble() * 32.0 - 16.0, rand.nextDouble() * 32.0 - 16.0)

			item.mailbox.scheduleAtFixedRate({ item.movement.velocity += Vector2d(rand.nextDouble() * 32.0 - 16.0, rand.nextDouble() * 32.0 - 16.0) }, 1000 + rand.nextLong(-100, 100), 1000 + rand.nextLong(-100, 100), TimeUnit.MILLISECONDS)
			//item.movement.applyVelocity(Vector2d(rand.nextDouble() * 1000.0 - 500.0, rand.nextDouble() * 1000.0 - 500.0))
		}

		client.connectToLocalServer(client, server.channels.createLocalChannel(), UUID.randomUUID())
	}

	//ent.position += Vector2d(y = 14.0, x = -10.0)
	client.camera.pos = Vector2d(238.0, 685.0)
	//client.camera.pos = Vector2f(0f, 0f)

	client.onDrawGUI {
		client.font.render("Camera: ${client.camera.pos} ${client.settings.zoom}", y = 140f, scale = 0.25f)
		client.font.render("Cursor: ${client.mouseCoordinates} -> ${client.screenToWorld(client.mouseCoordinates)}", y = 160f, scale = 0.25f)
		client.font.render("World chunk: ${client.world?.chunkFromCell(client.camera.pos)}", y = 180f, scale = 0.25f)
	}

	//ent.spawn()

	client.input.addScrollCallback { _, x, y ->
		if (y > 0.0) {
			client.settings.zoom *= y.toFloat() * 2f
		} else if (y < 0.0) {
			client.settings.zoom /= -y.toFloat() * 2f
		}
	}

	while (client.renderFrame()) {
		val ply = client.activeConnection?.character

		if (ply != null) {
			client.camera.pos = ply.position

			ply.movement.controlMove = if (client.input.KEY_A_DOWN) Direction.LEFT else if (client.input.KEY_D_DOWN) Direction.RIGHT else null
			ply.movement.controlJump = client.input.KEY_SPACE_DOWN
			ply.movement.controlRun = !client.input.KEY_LEFT_SHIFT_DOWN
		} else {
			client.camera.pos += Vector2d(
				(if (client.input.KEY_A_DOWN) -Starbound.TICK_TIME_ADVANCE * 32f / client.settings.zoom else 0.0) + (if (client.input.KEY_D_DOWN) Starbound.TICK_TIME_ADVANCE * 32f / client.settings.zoom else 0.0),
				(if (client.input.KEY_W_DOWN) Starbound.TICK_TIME_ADVANCE * 32f / client.settings.zoom else 0.0) + (if (client.input.KEY_S_DOWN) -Starbound.TICK_TIME_ADVANCE * 32f / client.settings.zoom else 0.0)
			)
		}

		if (client.input.KEY_ESCAPE_PRESSED) {
			glfwSetWindowShouldClose(client.window, true)
		}
	}
}
