package ru.dbotthepony.kstarbound.world.api

import ru.dbotthepony.kstarbound.Registry
import ru.dbotthepony.kstarbound.defs.tile.BuiltinMetaMaterials
import ru.dbotthepony.kstarbound.defs.tile.MaterialModifier
import ru.dbotthepony.kstarbound.defs.tile.TileDefinition

data class ImmutableTileState(
	override var material: Registry.Entry<TileDefinition> = BuiltinMetaMaterials.NULL,
	override var modifier: Registry.Entry<MaterialModifier>? = null,
	override var color: TileColor = TileColor.DEFAULT,
	override var hueShift: Float = 0f,
	override var modifierHueShift: Float = 0f,
) : AbstractTileState() {
	override fun immutable(): ImmutableTileState {
		return this
	}

	override fun mutable(): MutableTileState {
		return MutableTileState(material, modifier, color, hueShift, modifierHueShift)
	}
}
